from sqlalchemy import create_engine, Column,Boolean, Integer, Float,String, Date, DateTime, ForeignKey, UniqueConstraint, Text
from sqlalchemy.ext.declarative import declarative_base

Base = declarative_base()
class Symbol(Base):
    __tablename__ = "symbols"
    __table_args__ = {'schema': 'tradingdb'}
    id = Column(Integer, primary_key=True)  
    instrument_key = Column(String, primary_key=True)
    stock_token = Column(String)
    instrumentname = Column(String)
    stock_code = Column(String)
    series = Column(String)
    expirydate = Column(Date) # Changed to Date
    strikeprice = Column(Float)
    optiontype = Column(String)
    calevel = Column(String)
    permittedtotrade = Column(Boolean) # Changed to Boolean
    issuecapital = Column(Float)
    warningqty = Column(Integer)
    freezeqty = Column(Integer)
    creditrating = Column(String)
    normalmarketstatus = Column(String)
    oddlotmarketstatus = Column(String)
    spotmarketstatus = Column(String)
    auctionmarketstatus = Column(String)
    normalmarketeligibility = Column(String)
    oddlotmarketeligibility = Column(String)
    spotmarketeligibility = Column(String)
    auctionmarketeligibility = Column(String)
    scripid = Column(String)
    issuerate = Column(Float)
    issuestartdate = Column(Date)
    interestpaymentdate = Column(Date)
    issuematuritydate = Column(Date)
    marginpercentage = Column(Float)
    minimumlotqty = Column(Integer)
    lotsize = Column(Integer)
    ticksize = Column(Float)
    companyname = Column(String)
    listingdate = Column(Date)
    expulsiondate = Column(Date)
    readmissiondate = Column(Date)
    recorddate = Column(Date)
    lowpricerange = Column(Float)
    highpricerange = Column(Float)
    securityexpirydate = Column(Date)
    nodeliverystartdate = Column(Date)
    nodeliveryenddate = Column(Date)
    mf = Column(String)
    aon = Column(String)
    participantinmarketindex = Column(String)
    bookclsstartdate = Column(Date)
    bookclsenddate = Column(Date)
    excercisestartdate = Column(Date)
    excerciseenddate = Column(Date)
    oldtoken = Column(String)
    assetinstrument = Column(String)
    assetname = Column(String)
    assettoken = Column(Integer)
    intrinsicvalue = Column(Float)
    extrinsicvalue = Column(Float)
    excercisestyle = Column(String)
    egm = Column(String)
    agm = Column(String)
    interest = Column(String)
    bonus = Column(String)
    rights = Column(String)
    dividends = Column(String)
    exallowed = Column(String)
    exrejectionallowed = Column(Boolean) # Changed to Boolean
    plallowed = Column(Boolean) # Changed to Boolean
    isthisasset = Column(Boolean) # Changed to Boolean
    iscorpadjusted = Column(Boolean) # Changed to Boolean
    localupdatedatetime = Column(DateTime)
    deleteflag = Column(Boolean) # Changed to Boolean
    remarks = Column(String)
    baseprice = Column(Float)
    exchangecode = Column(String)
    expirydate = Column(DateTime)
    exchange_code = Column(String)
    product_type = Column(String)

    __table_args__ = (UniqueConstraint('instrument_key'),)

